=== other/docker/esp32/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

include($ENV{IDF_PATH}/tools/cmake/project.cmake)
project(toxcore)
