=== other/docker/esp32/hello/CMakeLists.txt ===
set(COMPONENT_SRCS "hello_main.c")
set(COMPONENT_ADD_INCLUDEDIRS "")

register_component()
