=== debian/changelog ===
libtoxcore (0.2.18-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:47:58 +0000

libtoxcore (0.2.18-1build2) noble; urgency=medium

  * No-change rebuild against libvpx9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 23 Mar 2024 17:46:02 +0000

libtoxcore (0.2.18-1build1) noble; urgency=medium

  * Rebuild against new libvpx8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 17 Nov 2023 19:13:18 +0100

libtoxcore (0.2.18-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.1

 -- Yangfl <mmyangfl@gmail.com>  Fri, 07 Oct 2022 19:01:37 +0800
